#ifndef OBJ10_DB_H
#define OBJ10_DB_H
/*lint ++flb */

/* Raima Database Manager 11.0.0.1000 */

/* ----------------------------------------------------------------------------
 *
 * Raima Database Manager
 *
 * Copyright (c) 2012 Raima Inc.,  All rights reserved.
 *
 * Use of this software, whether in source code format, or in executable,
 * binary object code form, is governed by the Raima LICENSE which
 * is fully described in the LICENSE.TXT file, included within this
 * distribution of files.
 *
 * ----------------------------------------------------------------------------
 */

/* EXAMPLE - obj10 for C++ */
/* This is the DDL (Database Definition Language) for a database implementing
 * two one-to-many relationship using network model sets.  The database will 
 * implement the beginnings of an mp3 collection.  The one (owner) side
 * of the relationship is an artist records.  The many (member) side of the 
 * relationship is the album record.  There will be a second set where the one
 * side is the album record and the many side is a track record.

 * The artist name and album title will be index so they can be retrieved in
 * sorted order.  The index will also allow an application to perform an
 * efficient search on those fields.
 * 
 * This schema file should be processed using the ddlp utility using the
 * -c and -cpp options to create an embedded dbd file.  The -c option will 
 * generate a c header file (obj10_db_dbd.h) and a c source file 
 * (obj10_db_dbd.c) which can be compiled into the application and used with 
 * the Open method to create the database dictionary if it does not already 
 * exist.
 */


/* database obj10_db record/key structure declarations */

struct artist {
   char name[100];
};

struct album {
   char title[100];
};

struct track {
   char name[100];
};

/* record, field and set table entry definitions */

/* File Id Constants */

/* Record Name Constants */
#define ARTIST 10000
#define ALBUM 10001
#define TRACK 10002

/* Field Name Constants */
#define ARTIST_NAME 0L
#define ALBUM_TITLE 1000L
#define TRACK_NAME 2000L

/* Set Name Constants */
#define ARTIST_ALBUM 20000
#define ALBUM_TRACK 20001

/* Field Sizes */
#define SIZEOF_ARTIST_NAME 100
#define SIZEOF_ALBUM_TITLE 100
#define SIZEOF_TRACK_NAME 100

/*lint --flb */
#endif    /* OBJ10_DB_H */
