#include "obj10_db_api.h"
#include "obj10_db_dbd.h"

using namespace RDM_CPP;

Db_obj10_db Db_obj10_db::Open (char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), "obj10_db", mode, &obj10_db_dbd, sizeof(obj10_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj10_db Db_obj10_db::Open (wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), L"obj10_db", mode, &obj10_db_dbd, sizeof(obj10_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

Db_obj10_db Db_obj10_db::Open (const char *name, const char *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj10_db_dbd, sizeof(obj10_db_dbd));
}

#if !defined(RDM_NO_UNICODE)
Db_obj10_db Db_obj10_db::Open (const wchar_t *name, const wchar_t *mode) throw (rdm_exception&) {
    return Db::Open (Type (), name, mode, &obj10_db_dbd, sizeof(obj10_db_dbd));
}
#endif /*RDM_NO_UNICODE*/

dbType Db_obj10_db::Type (void) {
    char static type;
    return &type;
}

Db_obj10_db::Db_obj10_db (void) throw () {
}

Db_obj10_db::Db_obj10_db (const Db& db) throw () : Db (db, Type()) {
}

Db_obj10_db::Db_obj10_db (const Db_obj10_db& db) throw () : Db (db) {
}

Db_obj10_db::Db_obj10_db (IDb *idb) : Db (idb) {
}

Db_obj10_db& Db_obj10_db::operator = (const Db& db) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), db);
    return *this;
}

Db_obj10_db& Db_obj10_db::operator = (const Db_obj10_db& db) throw () {
    *((Db *)this) = db;
    return *this;
}

Db_obj10_db::~Db_obj10_db () {
}

Cursor_artist Db_obj10_db::New_artist_record (void) const throw (rdm_exception&) {
    return Cursor_artist (NewRecords (Cursor_artist::Type ()));
}

Cursor_artist Db_obj10_db::New_artist_recordWithFieldValues (struct artist *fields) const throw (rdm_exception&) {
    return Cursor_artist (NewRecordsWithFieldValues (Cursor_artist::Type (), fields));
}

Cursor_album Db_obj10_db::New_album_record (void) const throw (rdm_exception&) {
    return Cursor_album (NewRecords (Cursor_album::Type ()));
}

Cursor_album Db_obj10_db::New_album_recordWithFieldValues (struct album *fields) const throw (rdm_exception&) {
    return Cursor_album (NewRecordsWithFieldValues (Cursor_album::Type (), fields));
}

Cursor_track Db_obj10_db::New_track_record (void) const throw (rdm_exception&) {
    return Cursor_track (NewRecords (Cursor_track::Type ()));
}

Cursor_track Db_obj10_db::New_track_recordWithFieldValues (struct track *fields) const throw (rdm_exception&) {
    return Cursor_track (NewRecordsWithFieldValues (Cursor_track::Type (), fields));
}

Cursor_artist Db_obj10_db::Get_artist_records (void) const throw (rdm_exception&) {
    return Cursor_artist (GetRecords (Cursor_artist::Type ()));
}

Cursor_album Db_obj10_db::Get_album_records (void) const throw (rdm_exception&) {
    return Cursor_album (GetRecords (Cursor_album::Type ()));
}

Cursor_track Db_obj10_db::Get_track_records (void) const throw (rdm_exception&) {
    return Cursor_track (GetRecords (Cursor_track::Type ()));
}

Cursor_artist Db_obj10_db::Get_artist_recordsBy_name () const throw (rdm_exception&) {
    return Cursor_artist (GetRecordsByKey (ARTIST_NAME));
}

Cursor_album Db_obj10_db::Get_album_recordsBy_title () const throw (rdm_exception&) {
    return Cursor_album (GetRecordsByKey (ALBUM_TITLE));
}

Cursor_track Db_obj10_db::Get_track_recordsBy_name () const throw (rdm_exception&) {
    return Cursor_track (GetRecordsByKey (TRACK_NAME));
}

recordType Cursor_artist::Type (void) {
    return ARTIST;
}

Cursor_artist::Cursor_artist (void) throw () {
}

Cursor_artist::Cursor_artist (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_artist::Cursor_artist (const Cursor_artist& cursor) throw () : Cursor (cursor) {
}

Cursor_artist& Cursor_artist::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_artist& Cursor_artist::operator = (const Cursor_artist& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_album Cursor_artist::Get_artist_album_members (void) const throw (rdm_exception&) {
    return GetMembers (ARTIST_ALBUM);
}

int32_t Cursor_artist::Get_artist_album_count (void) const throw (rdm_exception&) {
    return GetMemberCount (ARTIST_ALBUM);
}

Cursor_artist Cursor_artist::GetRecordsBy_name () const throw (rdm_exception&) {
    return Cursor_artist (GetRecordsByKey (ARTIST_NAME));
}

void Cursor_artist::KeyFindBy_name (char name_val[100]) const throw (rdm_exception&) {
    FindRecordsByKey(ARTIST_NAME, 0, 0, name_val);
}

void Cursor_artist::SetFieldValues (const struct artist *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_artist::GetFieldValues (struct artist *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_artist::Set_name (const char name_val[100]) const throw (rdm_exception&) {
    SetField (ARTIST_NAME, name_val);
}

void Cursor_artist::Get_name (char name_val[100]) const throw (rdm_exception&) {
    GetField (ARTIST_NAME, name_val);
}

Cursor_artist::~Cursor_artist () {
}

recordType Cursor_album::Type (void) {
    return ALBUM;
}

Cursor_album::Cursor_album (void) throw () {
}

Cursor_album::Cursor_album (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_album::Cursor_album (const Cursor_album& cursor) throw () : Cursor (cursor) {
}

Cursor_album& Cursor_album::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_album& Cursor_album::operator = (const Cursor_album& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_track Cursor_album::Get_album_track_members (void) const throw (rdm_exception&) {
    return GetMembers (ALBUM_TRACK);
}

int32_t Cursor_album::Get_album_track_count (void) const throw (rdm_exception&) {
    return GetMemberCount (ALBUM_TRACK);
}

Cursor_album Cursor_album::Get_artist_album_siblings (void) const throw (rdm_exception&) {
    return GetSiblings (ARTIST_ALBUM);
}

void Cursor_album::Connect_artist_album (const Cursor_artist &owner) const throw (rdm_exception&) {
    Connect (ARTIST_ALBUM, owner, FALSE);
}

void Cursor_album::Reconnect_artist_album (const Cursor_artist &owner) const throw (rdm_exception&) {
    Connect (ARTIST_ALBUM, owner, TRUE);
}

void Cursor_album::Disconnect_artist_album (void) const throw (rdm_exception&) {
    Disconnect (ARTIST_ALBUM);
}

Cursor_artist Cursor_album::Get_artist_album_owner (void) const throw (rdm_exception&) {
    return GetOwner (ARTIST_ALBUM);
}

Cursor_album Cursor_album::GetRecordsBy_title () const throw (rdm_exception&) {
    return Cursor_album (GetRecordsByKey (ALBUM_TITLE));
}

void Cursor_album::KeyFindBy_title (char title_val[100]) const throw (rdm_exception&) {
    FindRecordsByKey(ALBUM_TITLE, 0, 0, title_val);
}

void Cursor_album::SetFieldValues (const struct album *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_album::GetFieldValues (struct album *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_album::Set_title (const char title_val[100]) const throw (rdm_exception&) {
    SetField (ALBUM_TITLE, title_val);
}

void Cursor_album::Get_title (char title_val[100]) const throw (rdm_exception&) {
    GetField (ALBUM_TITLE, title_val);
}

Cursor_album::~Cursor_album () {
}

recordType Cursor_track::Type (void) {
    return TRACK;
}

Cursor_track::Cursor_track (void) throw () {
}

Cursor_track::Cursor_track (const Cursor& cursor) throw (rdm_exception&) : Cursor (cursor, Type ()) {
}

Cursor_track::Cursor_track (const Cursor_track& cursor) throw () : Cursor (cursor) {
}

Cursor_track& Cursor_track::operator = (const Cursor& cursor) throw (rdm_exception&) {
    AssignAndVerifyType (Type (), cursor);
    return *this;
}

Cursor_track& Cursor_track::operator = (const Cursor_track& cursor) throw () {
    *((Cursor *)this) = cursor;
    return *this;
}

Cursor_track Cursor_track::Get_album_track_siblings (void) const throw (rdm_exception&) {
    return GetSiblings (ALBUM_TRACK);
}

void Cursor_track::Connect_album_track (const Cursor_album &owner) const throw (rdm_exception&) {
    Connect (ALBUM_TRACK, owner, FALSE);
}

void Cursor_track::Reconnect_album_track (const Cursor_album &owner) const throw (rdm_exception&) {
    Connect (ALBUM_TRACK, owner, TRUE);
}

void Cursor_track::Disconnect_album_track (void) const throw (rdm_exception&) {
    Disconnect (ALBUM_TRACK);
}

Cursor_album Cursor_track::Get_album_track_owner (void) const throw (rdm_exception&) {
    return GetOwner (ALBUM_TRACK);
}

Cursor_track Cursor_track::GetRecordsBy_name () const throw (rdm_exception&) {
    return Cursor_track (GetRecordsByKey (TRACK_NAME));
}

void Cursor_track::KeyFindBy_name (char name_val[100]) const throw (rdm_exception&) {
    FindRecordsByKey(TRACK_NAME, 0, 0, name_val);
}

void Cursor_track::SetFieldValues (const struct track *fields) const throw (rdm_exception&) {
    Cursor::SetFieldValues (Type (), fields);
}

void Cursor_track::GetFieldValues (struct track *fields) const throw (rdm_exception&) {
    Cursor::GetFieldValues (Type (), fields);
}

void Cursor_track::Set_name (const char name_val[100]) const throw (rdm_exception&) {
    SetField (TRACK_NAME, name_val);
}

void Cursor_track::Get_name (char name_val[100]) const throw (rdm_exception&) {
    GetField (TRACK_NAME, name_val);
}

Cursor_track::~Cursor_track () {
}

